/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the SuccessResponseAllOf type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &SuccessResponseAllOf{}

// SuccessResponseAllOf struct for SuccessResponseAllOf
type SuccessResponseAllOf struct {
	Data     []interface{}          `json:"data,omitempty"`
	Key      []interface{}          `json:"key,omitempty"`
	Type     []interface{}          `json:"type,omitempty"`
	RowCount *int32                 `json:"row_count,omitempty"`
	Duration *float32               `json:"duration,omitempty"`
	Matrix   map[string]interface{} `json:"matrix,omitempty"`
}

// NewSuccessResponseAllOf instantiates a new SuccessResponseAllOf object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewSuccessResponseAllOf() *SuccessResponseAllOf {
	this := SuccessResponseAllOf{}
	return &this
}

// NewSuccessResponseAllOfWithDefaults instantiates a new SuccessResponseAllOf object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewSuccessResponseAllOfWithDefaults() *SuccessResponseAllOf {
	this := SuccessResponseAllOf{}
	return &this
}

// GetData returns the Data field value if set, zero value otherwise.
func (o *SuccessResponseAllOf) GetData() []interface{} {
	if o == nil || IsNil(o.Data) {
		var ret []interface{}
		return ret
	}
	return o.Data
}

// GetDataOk returns a tuple with the Data field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SuccessResponseAllOf) GetDataOk() ([]interface{}, bool) {
	if o == nil || IsNil(o.Data) {
		return nil, false
	}
	return o.Data, true
}

// HasData returns a boolean if a field has been set.
func (o *SuccessResponseAllOf) HasData() bool {
	if o != nil && !IsNil(o.Data) {
		return true
	}

	return false
}

// SetData gets a reference to the given []interface{} and assigns it to the Data field.
func (o *SuccessResponseAllOf) SetData(v []interface{}) {
	o.Data = v
}

// GetKey returns the Key field value if set, zero value otherwise.
func (o *SuccessResponseAllOf) GetKey() []interface{} {
	if o == nil || IsNil(o.Key) {
		var ret []interface{}
		return ret
	}
	return o.Key
}

// GetKeyOk returns a tuple with the Key field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SuccessResponseAllOf) GetKeyOk() ([]interface{}, bool) {
	if o == nil || IsNil(o.Key) {
		return nil, false
	}
	return o.Key, true
}

// HasKey returns a boolean if a field has been set.
func (o *SuccessResponseAllOf) HasKey() bool {
	if o != nil && !IsNil(o.Key) {
		return true
	}

	return false
}

// SetKey gets a reference to the given []interface{} and assigns it to the Key field.
func (o *SuccessResponseAllOf) SetKey(v []interface{}) {
	o.Key = v
}

// GetType returns the Type field value if set, zero value otherwise.
func (o *SuccessResponseAllOf) GetType() []interface{} {
	if o == nil || IsNil(o.Type) {
		var ret []interface{}
		return ret
	}
	return o.Type
}

// GetTypeOk returns a tuple with the Type field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SuccessResponseAllOf) GetTypeOk() ([]interface{}, bool) {
	if o == nil || IsNil(o.Type) {
		return nil, false
	}
	return o.Type, true
}

// HasType returns a boolean if a field has been set.
func (o *SuccessResponseAllOf) HasType() bool {
	if o != nil && !IsNil(o.Type) {
		return true
	}

	return false
}

// SetType gets a reference to the given []interface{} and assigns it to the Type field.
func (o *SuccessResponseAllOf) SetType(v []interface{}) {
	o.Type = v
}

// GetRowCount returns the RowCount field value if set, zero value otherwise.
func (o *SuccessResponseAllOf) GetRowCount() int32 {
	if o == nil || IsNil(o.RowCount) {
		var ret int32
		return ret
	}
	return *o.RowCount
}

// GetRowCountOk returns a tuple with the RowCount field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SuccessResponseAllOf) GetRowCountOk() (*int32, bool) {
	if o == nil || IsNil(o.RowCount) {
		return nil, false
	}
	return o.RowCount, true
}

// HasRowCount returns a boolean if a field has been set.
func (o *SuccessResponseAllOf) HasRowCount() bool {
	if o != nil && !IsNil(o.RowCount) {
		return true
	}

	return false
}

// SetRowCount gets a reference to the given int32 and assigns it to the RowCount field.
func (o *SuccessResponseAllOf) SetRowCount(v int32) {
	o.RowCount = &v
}

// GetDuration returns the Duration field value if set, zero value otherwise.
func (o *SuccessResponseAllOf) GetDuration() float32 {
	if o == nil || IsNil(o.Duration) {
		var ret float32
		return ret
	}
	return *o.Duration
}

// GetDurationOk returns a tuple with the Duration field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SuccessResponseAllOf) GetDurationOk() (*float32, bool) {
	if o == nil || IsNil(o.Duration) {
		return nil, false
	}
	return o.Duration, true
}

// HasDuration returns a boolean if a field has been set.
func (o *SuccessResponseAllOf) HasDuration() bool {
	if o != nil && !IsNil(o.Duration) {
		return true
	}

	return false
}

// SetDuration gets a reference to the given float32 and assigns it to the Duration field.
func (o *SuccessResponseAllOf) SetDuration(v float32) {
	o.Duration = &v
}

// GetMatrix returns the Matrix field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *SuccessResponseAllOf) GetMatrix() map[string]interface{} {
	if o == nil {
		var ret map[string]interface{}
		return ret
	}
	return o.Matrix
}

// GetMatrixOk returns a tuple with the Matrix field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *SuccessResponseAllOf) GetMatrixOk() (map[string]interface{}, bool) {
	if o == nil || IsNil(o.Matrix) {
		return map[string]interface{}{}, false
	}
	return o.Matrix, true
}

// HasMatrix returns a boolean if a field has been set.
func (o *SuccessResponseAllOf) HasMatrix() bool {
	if o != nil && IsNil(o.Matrix) {
		return true
	}

	return false
}

// SetMatrix gets a reference to the given map[string]interface{} and assigns it to the Matrix field.
func (o *SuccessResponseAllOf) SetMatrix(v map[string]interface{}) {
	o.Matrix = v
}

func (o SuccessResponseAllOf) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o SuccessResponseAllOf) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Data) {
		toSerialize["data"] = o.Data
	}
	if !IsNil(o.Key) {
		toSerialize["key"] = o.Key
	}
	if !IsNil(o.Type) {
		toSerialize["type"] = o.Type
	}
	if !IsNil(o.RowCount) {
		toSerialize["row_count"] = o.RowCount
	}
	if !IsNil(o.Duration) {
		toSerialize["duration"] = o.Duration
	}
	if o.Matrix != nil {
		toSerialize["matrix"] = o.Matrix
	}
	return toSerialize, nil
}

type NullableSuccessResponseAllOf struct {
	value *SuccessResponseAllOf
	isSet bool
}

func (v NullableSuccessResponseAllOf) Get() *SuccessResponseAllOf {
	return v.value
}

func (v *NullableSuccessResponseAllOf) Set(val *SuccessResponseAllOf) {
	v.value = val
	v.isSet = true
}

func (v NullableSuccessResponseAllOf) IsSet() bool {
	return v.isSet
}

func (v *NullableSuccessResponseAllOf) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableSuccessResponseAllOf(val *SuccessResponseAllOf) *NullableSuccessResponseAllOf {
	return &NullableSuccessResponseAllOf{value: val, isSet: true}
}

func (v NullableSuccessResponseAllOf) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableSuccessResponseAllOf) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
